%define anolis_release 1

%bcond_without selinux
%bcond_without check

Summary: GNU file archiving program
Name: tar
Epoch: 2
Version: 1.35
Release: %{anolis_release}%{?dist}
License: GPLv3+
URL: https://www.gnu.org/software/tar/

Source0: https://ftp.gnu.org/gnu/tar/tar-%{version}.tar.xz
Source1: https://ftp.gnu.org/gnu/tar/tar-%{version}.tar.xz.sig

Patch1:  tar-1.28-loneZeroWarning.patch
Patch2:  tar-1.28-vfatTruncate.patch
Patch3:  tar-1.29-wildcards.patch
Patch4:  tar-1.28-atime-rofs.patch
Patch9:  tar-1.28-document-exclude-mistakes.patch
Patch10: tar-1.33-fix-capabilities-test.patch
Patch11: tar-1.35-add-forgotten-tests-from-upstream.patch
Patch12: tar-1.35-revert-fix-savannah-bug-633567.patch
Patch1000: 1000-tar-1.35-Fix-spurious-diagnostic-during-extraction-of-.-with-.patch

BuildRequires: make
BuildRequires:  gcc
BuildRequires: autoconf automake texinfo gettext libacl-devel

%if %{with check}
# cover needs of tar's testsuite
BuildRequires: attr acl policycoreutils
%endif

%if %{with selinux}
BuildRequires: libselinux-devel
%endif
Provides: bundled(gnulib)
Provides: bundled(paxutils)
Provides: /bin/tar
Provides: /bin/gtar

%description
The GNU tar program saves many files together in one archive and can
restore individual files (or all of the files) from that archive. Tar
can also be used to add supplemental files to an archive and to update
or list files in the archive. Tar includes multivolume support,
automatic archive compression/decompression, the ability to perform
remote archives, and the ability to perform incremental and full
backups.

If you want to use tar for remote backups, you also need to install
the rmt package on the remote box.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1
autoreconf -v

# Keep only entries related to the latest release.
mv ChangeLog{,~}
awk 'stop = false; /^2014-07-27/ { stop = true; exit }; { print }' \
    < ChangeLog~ > ChangeLog


%build
%configure \
    %{!?with_selinux:--without-selinux} \
    --with-lzma="xz --format=lzma" \
    DEFAULT_RMT_DIR=%{_sysconfdir} \
    RSH=/usr/bin/ssh

%make_build


%install
%make_install

ln -s tar $RPM_BUILD_ROOT%{_bindir}/gtar
rm -f $RPM_BUILD_ROOT/%{_infodir}/dir
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
ln -s tar.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/gtar.1

# XXX Nuke unpackaged files.
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/rmt
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/rmt.8*

%find_lang %name

%generate_compatibility_deps

%check
%if %{with check}
rm -f $RPM_BUILD_ROOT/test/testsuite
# make check TESTSUITEFLAGS='-k \!dirrem01,\!dirrem02' || (
make check || (
    # get the error log
    set +x
    find -name testsuite.log | while read line; do
        echo "=== $line ==="
        cat "$line"
        echo
    done
    false
)
%endif


%files -f %{name}.lang
%license COPYING
%dir %{abidir}
%{_bindir}/tar
%{_bindir}/gtar
%{abidir}/tar-option.list
%{_mandir}/man1/tar.1*
%{_mandir}/man1/gtar.1*
%{_infodir}/tar.info*

%files doc
%doc AUTHORS README THANKS NEWS ChangeLog

%changelog
* Thu Mar 20 2025 Weisson <Weisson@linux.alibaba.com> - 2:1.35-1
- Update to 1.35 from 1.34
- Remove patches that exist in the new version
- Fix spurious diagnostic during extraction of . with  --keep-newer-files
- Add exclude17 and exclude18 tests which were forgotten by
- Revert "Fix savannah bug #63567"
 [Patches cherry-picked from c10s. Original changelog:
   - Revert "Fix savannah bug #63567" (1.35-5)]


* Sun Jul 23 2023 Funda Wang <fundawang@yeah.net> - 2:1.34-4
- Fix CVE-2022-48303

* Tue Dec 06 2022 Shawn Wang <shawnwang@linux.alibaba.com> - 2:1.34-3
- add abi/api info
- add some patches

* Mon Oct 10 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2:1.34-2
- add doc package

* Wed Mar 09 2022 Hongwei Qin <qhw01063182@alibaba-inc.com> - 2:1.34-1
- Rebase to version 1.34
- Init for Anolis OS 23
